import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.dao.GenericRawResults;
import com.j256.ormlite.dao.RuntimeExceptionDao;
import com.j256.ormlite.jdbc.JdbcConnectionSource;
import com.j256.ormlite.stmt.QueryBuilder;
import com.j256.ormlite.support.ConnectionSource;

public class AccountService {
    // private Dao<Account, Integer> accountDao;
     private Console console = new Console();

    public void create(Dao<Account, Integer> accountDao){
        try {
            String name = console.getCMDFromUser("Enter name: ");
            String password = console.getCMDFromUser("Set password: ");
            Account account = new Account(name, password);
            accountDao.create(account);
            int id = account.getId();
            Printer.printMessage("\nRecord " + id + " created.\n");
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public void read(Dao<Account, Integer> accountDao) {
        try {
            List<Account> accountList = accountDao.queryForAll();
            for (Account e: accountList) {
                System.out.printf("|%-3s| |%-10s| |%-10s|" , e.getId(), e.getName(), e.getPassword());
                System.out.println("\n");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public void update(Dao<Account, Integer> accountDao) {
        boolean updateAccountMenuOpen = true;

        while (updateAccountMenuOpen){
            read(accountDao);
            int idToUpdate = Integer.parseInt(console.getCMDFromUser("Enter account to update: \n"));

            try {
                if (accountDao.idExists(idToUpdate)) {
                        Account accountToUpdate = getById(accountDao, idToUpdate);
                        int userSelection = console.getUpdateMenu();

                        switch (userSelection){
                            case 1 : //update name
                                accountToUpdate.setName(console.updateField());
                                accountDao.update(accountToUpdate);

                                break;
                            case 2 : //update password
                                accountToUpdate.setPassword(console.updateField());
                                accountDao.update(accountToUpdate);
                                break;
                            case 3 : //quit
                                Printer.printMessage("Returning to Main\n");
                                updateAccountMenuOpen = false;
                        }
               }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    public void deleteId(Dao accountDao, int idToDelete){

        try {
            if (accountDao.idExists(idToDelete)) {
                accountDao.deleteById(idToDelete);
                Printer.printMessage("\nId deleted\n");
            }
            else {
                Printer.printMessage("\nId does not exist\n");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public Account getById(Dao accountDao, int id){
        try {
            return (Account)accountDao.queryForId(id);
        } catch (SQLException e) {
            e.printStackTrace();
        }
        Printer.printMessage("Failed to get Account");
        return null;
    }
}
